Unit Keyboard;   { By Pino Navato <pnavato@poboxes.com> }
{$S-,D-}

interface

   const CheckBreak: boolean = true;

   function KeyPressed: boolean;
   function ReadKey: char;


implementation
uses Dos;

var OldInt1B    : pointer;
    OldExitProc : pointer;
    ScanCode    : byte;         { 0 by default }
    BreakFlag	: boolean;	{ False by default }


procedure Break;
   begin
	halt(255)
   end;


function KeyPressed: boolean; assembler;
   asm
	cmp	BreakFlag, 0
	je	@1
	jmp	Break
@1:	cmp	ScanCode,0
	jne	@2
	mov	ah,1
	int	16h
	mov	al,0
	jz	@exit
@2:	mov	al,1
@exit:
   end;


function ReadKey: char; assembler;
   asm
	cmp	BreakFlag, 0
	je	@1
	jmp	Break
@1:	mov	al,ScanCode
	mov	ScanCode,0
	or	al,al
	jne	@exit
	xor	ah,ah
	int	16h
	or	al,al
	jne	@exit
	mov	ScanCode,ah
	or	ah,ah
	jne	@exit
	mov	al,'C'-64	{ Convert Ctrl-Break to Ctrl-C }
@exit:
   end;


procedure ExitHandler; far;
begin
   ExitProc := OldExitProc;
   SetIntVec($1B, @OldInt1B)   { Restore the old vector }
end;


procedure NewInt1B; assembler;
   asm
      push  ax
      push  ds
      mov   ax,SEG @data
      mov   ds,ax
      cmp   CheckBreak,0
      je    @exit
      mov   BreakFlag, 1
@exit:
      pop  ds
      pop  ax
      iret
   end;


begin  { Initialization }
   GetIntVec($1B, OldInt1B);
   SetIntVec($1B, @NewInt1B);   { Insert NewInt1B into the keyboard chain }
   OldExitProc := ExitProc;
   ExitProc := @ExitHandler
end.
